'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _default7 = _interopDefault(require('ramda/src/map'));
var _default6 = _interopDefault(require('ramda/src/addIndex'));
var _default5 = _interopDefault(require('ramda/src/concat'));
var _default4 = _interopDefault(require('ramda/src/reduce'));
var _default3 = _interopDefault(require('ramda/src/add'));
var _default2 = _interopDefault(require('ramda/src/multiply'));
var _default = _interopDefault(require('ramda/src/pipe'));
var _default14 = _interopDefault(require('ramda/src/flatten'));
var _default13 = _interopDefault(require('ramda/src/subtract'));
var _default12 = _interopDefault(require('ramda/src/juxt'));
var _default11 = _interopDefault(require('ramda/src/gte'));
var _default10 = _interopDefault(require('ramda/src/findLastIndex'));
var _default8 = _interopDefault(require('ramda/src/scan'));
var _default3$1 = _interopDefault(require('ramda/src/__'));
var _default6$1 = _interopDefault(require('ramda/src/repeat'));
var _default5$1 = _interopDefault(require('ramda/src/divide'));
var _default4$1 = _interopDefault(require('ramda/src/always'));
var _default2$1 = _interopDefault(require('ramda/src/range'));
var _default13$1 = _interopDefault(require('ramda/src/omit'));
var _default12$1 = _interopDefault(require('ramda/src/drop'));
var _default11$1 = _interopDefault(require('ramda/src/equals'));
var _default10$1 = _interopDefault(require('ramda/src/nthArg'));
var _default9 = _interopDefault(require('ramda/src/isNil'));
var _default8$1 = _interopDefault(require('ramda/src/max'));
var _default7$1 = _interopDefault(require('ramda/src/identity'));
var _default6$2 = _interopDefault(require('ramda/src/not'));
var _default5$2 = _interopDefault(require('ramda/src/is'));
var _default4$2 = _interopDefault(require('ramda/src/pathOr'));
var _default2$2 = _interopDefault(require('ramda/src/prop'));
var _default$1 = _interopDefault(require('ramda/src/propOr'));
var React = require('react');
var rxjsObservableConfig = _interopDefault(require('recompose/rxjsObservableConfig'));
var setObservableConfig = _interopDefault(require('recompose/setObservableConfig'));
var createEventHandler = _interopDefault(require('recompose/createEventHandler'));
var compose = _interopDefault(require('recompose/compose'));
var setPropTypes = _interopDefault(require('recompose/setPropTypes'));
var mapPropsStream = _interopDefault(require('recompose/mapPropsStream'));
var withHandlers = _interopDefault(require('recompose/withHandlers'));
var withPropsOnChange = _interopDefault(require('recompose/withPropsOnChange'));
var lifecycle = _interopDefault(require('recompose/lifecycle'));
var Rx = _interopDefault(require('rxjs'));
var PropTypes = _interopDefault(require('prop-types'));

var START_CODE = 33;
var END_CODE = 126;
var RANGE = END_CODE - START_CODE;

var randomChar = _default(Math.random, _default2(RANGE), Math.floor, _default3(START_CODE), String.fromCharCode);

var array2String = _default4(_default5, '');

var mixcramble = function mixcramble(_) {
  var text = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var mask = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  return _default(_default6(_default7)(function (d, i) {
    return d === 0 ? randomChar() : text[i] || '';
  }), array2String)(mask);
};

var descramble = function descramble() {
  var result = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
  var text = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var mask = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  return _default(_default6(_default7)(function (d, i) {
    return d === 0 ? result[i] || '' : text[i] || '';
  }), array2String)(mask);
};

var scramble = function scramble() {
  var result = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
  var mask = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  return _default(_default6(_default7)(function (d, i) {
    return d === 0 ? result[i] || '' : randomChar();
  }), array2String)(mask);
};

var getRandomMask = _default(_default2$1(0), _default7(_default(Math.random, Math.round)));

var getFullMask = _default(_default2$1(0), _default7(_default4$1(1)));

var getForwardMask = function getForwardMask(length) {
  var roll = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : length;
  var count = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : length;

  var base = _default(_default5$1, Math.floor, _default6$1(_default3$1, length))(roll, length);

  for (var i = 0; i < roll % length; i++) {
    base[i]++;
  }

  return _default(_default8(_default3, 0), _default10(_default11(roll - count + 1)), _default12([_default6$1(1), _default(_default13(length), _default6$1(0))]), _default14)(base);
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

setObservableConfig(rxjsObservableConfig);

var omitProps = ['autoStart', 'bindMethod', 'pause', 'preScramble', 'reset', 'restart', 'speed', 'start', 'steps', 'text'];

var speed = {
  fast: 25,
  medium: 50,
  slow: 100
};

var index = compose(setPropTypes({
  autoStart: PropTypes.bool,
  bindMethod: PropTypes.func,
  mouseEnterTrigger: PropTypes.oneOf(['start', 'pause', 'reset', 'restart']),
  mouseLeaveTrigger: PropTypes.oneOf(['start', 'pause', 'reset', 'restart']),
  speed: PropTypes.string,
  steps: PropTypes.array,
  text: PropTypes.string
}), mapPropsStream(function (props$) {
  var _createEventHandler = createEventHandler(),
      start = _createEventHandler.handler,
      start$ = _createEventHandler.stream;

  var _createEventHandler2 = createEventHandler(),
      pause = _createEventHandler2.handler,
      pause$ = _createEventHandler2.stream;

  var _createEventHandler3 = createEventHandler(),
      reset = _createEventHandler3.handler,
      reset$ = _createEventHandler3.stream;

  var queue$ = new Rx.Subject();
  var counter$ = new Rx.Subject();
  var result$ = new Rx.Subject();

  var autoStart$ = props$.map(_default$1(false, 'autoStart')).distinctUntilChanged();

  var preScramble$ = props$.map(_default$1(false, 'preScramble')).distinctUntilChanged();

  var initText$ = props$.pluck('text').distinctUntilChanged().share();

  var steps$ = props$.map(_default$1([], 'steps')).distinctUntilChanged().share();

  var period$ = props$.map(_default$1('medium', 'speed')).distinctUntilChanged().map(_default2$2(_default3$1, speed));

  var currentStep$ = queue$.map(_default4$2({}, [0])).share();

  var text$ = currentStep$.map(_default2$2('text')).filter(_default5$2(String)).merge(initText$).distinctUntilChanged();

  var pauser$ = Rx.Observable.merge(autoStart$.map(_default6$2), pause$.mapTo(true), reset$.withLatestFrom(autoStart$, function (_, autoStart) {
    return !autoStart;
  }), start$.withLatestFrom(queue$, function (_, queue) {
    return queue.length === 0;
  }), queue$.map(function (queue) {
    return queue.length === 0;
  }).filter(_default7$1));

  var processor$ = currentStep$.map(function (_ref) {
    var action = _ref.action,
        type = _ref.type;

    switch (action) {
      case '+':
        return scramble;
      case '-':
        return type === 'forward' ? mixcramble : descramble;
      default:
        return _default7$1;
    }
  });

  var mask$ = Rx.Observable.combineLatest(currentStep$, counter$, result$, text$, function (_ref2, counter, result, text) {
    var type = _ref2.type,
        roll = _ref2.roll;

    var length = _default8$1(result.length, text.length);

    switch (type) {
      case 'random':
        return getRandomMask(length);
      case 'forward':
        return getForwardMask(length, roll, counter);
      case 'all':
      default:
        return getFullMask(length);
    }
  });

  var pausableTimer$ = pauser$.combineLatest(period$).switchMap(function (_ref3) {
    var _ref4 = slicedToArray(_ref3, 2),
        paused = _ref4[0],
        period = _ref4[1];

    return paused ? Rx.Observable.empty()
    // startWith 0 to send event immediately
    : Rx.Observable.interval(period).startWith(0);
  });

  Rx.Observable.merge(initText$.combineLatest(preScramble$, reset$.startWith(''), function (text, preScramble) {
    return preScramble ? scramble(null, text, getFullMask(text.length)) : text;
  }), pausableTimer$.withLatestFrom(result$, text$, processor$, mask$, function (_, result, text, processor, mask) {
    return processor(result, text, mask);
  })).subscribe(result$);

  Rx.Observable.merge(currentStep$.map(_default2$2('roll')), pausableTimer$.withLatestFrom(currentStep$, result$, text$, counter$, function (_, _ref5, result, text, counter) {
    var type = _ref5.type,
        action = _ref5.action;

    if (!_default9(counter)) {
      return counter - 1;
    }

    if (type === 'forward') {
      return _default8$1(result.length, text.length);
    }

    if (action === '-' && text === result) {
      return 0;
    }

    // endless loop when counter is undefined
    return;
  })).subscribe(counter$);

  Rx.Observable.merge(steps$, reset$.withLatestFrom(steps$, _default10$1(1)), counter$.filter(_default11$1(0)).withLatestFrom(queue$, _default10$1(1)).map(_default12$1(1))).subscribe(queue$);

  return props$.combineLatest(result$, function (props, result) {
    return _extends({}, props, {
      result: result,
      start: start,
      pause: pause,
      reset: reset
    });
  });
}), withPropsOnChange(['start', 'reset'], function (props) {
  return {
    restart: function restart() {
      props.reset();
      props.start();
    }
  };
}), lifecycle({
  componentDidMount: function componentDidMount() {
    var bindMethod = this.props.bindMethod;


    if (bindMethod) {
      bindMethod({
        start: this.props.start,
        pause: this.props.pause,
        reset: this.props.reset,
        restart: this.props.restart
      });
    }
  }
}), withHandlers({
  onMouseEnter: function onMouseEnter(props) {
    return function () {
      var onMouseEnter = props.onMouseEnter,
          mouseEnterTrigger = props.mouseEnterTrigger;

      var action = props[mouseEnterTrigger];

      _default5$2(Function, onMouseEnter) && onMouseEnter();
      _default5$2(Function, action) && action();
    };
  },
  onMouseLeave: function onMouseLeave(props) {
    return function () {
      var onMouseLeave = props.onMouseLeave,
          mouseLeaveTrigger = props.mouseLeaveTrigger;

      var action = props[mouseLeaveTrigger];

      _default5$2(Function, onMouseLeave) && onMouseLeave();
      _default5$2(Function, action) && action();
    };
  }
}))(function (_ref6) {
  var _ref6$result = _ref6.result,
      result = _ref6$result === undefined ? '' : _ref6$result,
      otherProps = objectWithoutProperties(_ref6, ['result']);
  return React.createElement(
    'span',
    _default13$1(omitProps, otherProps),
    result
  );
});

module.exports = index;
